]> diplodocus.org Git - nmh/blob - build_nmh
Change admonish(NULL, "foo") to inform("foo, continuing...").
[nmh] / build_nmh
1 #! /bin/sh
2 #
3 # Configures and builds nmh.
4 # * If this script is not invoked from an nmh source directory, it
5 # will attempt to download the nmh sources.
6 # * This script retrieves configuration from the first existing nmh
7 # installation on your $PATH, if any.
8 # * Unless the -y option is provided, this script then interactively
9 # walks you through confirmation of common configuration settings.
10 #
11 # This file can be downloaded and immediately run using, e.g.,
12 # wget http://git.savannah.gnu.org/cgit/nmh.git/plain/build_nmh
13 # sh build_nmh
14 #
15 # Typical usage:
16 # The first time you invoke this script, use the -i option to install
17 # nmh in the specified location. The script will walk you through the
18 # common nmh configuration settings. The -v option will cause display
19 # of brief progress indicators. Be sure to add the bin directory of
20 # the install location to your $PATH, if not already there.
21 # Subsequently, invoke this script with the -y option, to use the
22 # relevant configuration settings from the installed nmh without
23 # confirmation.
24 #
25 # Option summary:
26 # First time use:
27 # -b <branch> to specify branch to check out, only if downloading sources
28 # -i to install nmh
29 # -v to display progress
30 # Subsequent uses, assuming installed nmh bin directory is on $PATH:
31 # -y to accept all configuration options without confirmation
32 # Output control:
33 # -l <logfile name>, default 'build_nmh.log', - for stdout/stderr
34 # Advanced/developer use:
35 # -c to run 'make distcheck' instead of 'make check'
36 # -d to build nmh with asserts enabled and optimization disabled
37 # -s to use 'make superclean': requires recent autoconf and automake,
38 # see docs/README.developers
39 # -r to build rpm
40 #
41 # To disable colorization of the test summary, either unset the TERM
42 # environment variable or set it to dumb, e.g., TERM=dumb build_nmh.
43 #
44 # See the nmh MACHINES file for build prerequisites. In addition, the rpmbuild
45 # is required to be available if the -r option is used.
46
47 logfile=build_nmh.log
48 usage="usage:
49 [-b <branch>, only if downloading]
50 [-c to run 'make distcheck' instead of 'make check']
51 [-d to build nmh with asserts enabled and optimization disabled]
52 [-i to install nmh]
53 [-l <logfile name>, default '$logfile']
54 [-r to build rpm]
55 [-s to use 'make superclean': requires recent autoconf and automake]
56 [-v to display progress]
57 [-y to accept all configuration options without confirmation]"
58
59 #### Find location of a program. Bourne shell just puts the name in
60 #### $0 if it's found from the PATH, so search that if necessary.
61 finddir() {
62 case $1 in
63 */*) dirname "$1" ;;
64 * ) IFS=:
65 for d in $PATH; do
66 [ -f "${d:=.}/$1" -a -x "$d/$1" ] && printf %s "$d" && break
67 done ;;
68 esac
69 }
70
71 #### Make sure user sees error output even on early termination.
72 cleanup() {
73 if [ "$tmpfile" ]; then
74 #### Disable output redirection (and flush) so that we can grep.
75 #### If $tmpfile is null, don't need to do this because the
76 #### outputs weren't redirected, modulo a small race condition
77 #### between setting tmpfile and redirecting the outputs.
78 exec 1>&3 3>&- 2>&4 4>&-
79
80 if [ "$logfile" != - ]; then
81 exec 3>&1 >"$logfile" 2>&1
82 fi
83
84 if [ -f "$tmpfile" ]; then
85 cat "$tmpfile"
86 grep -E 'Error|warn' "$tmpfile"
87 rm "$tmpfile"
88 fi
89 fi
90
91 #### Put info message on stdout, and in log if not stdout.
92 if [ $status -ne 0 -o $verbose -ge 1 -o "$directory" ]; then
93 [ $status -eq 0 ] && result=succeeded || result=failed
94 if [ "$logfile" = - ]; then
95 echo "build $result"
96 else
97 message="build $result, build log is in ${directory:+$directory/}$logfile"
98 echo "$message" >&3
99 fi
100 fi
101
102 #### Heirloom shell does not like "trap - signal".
103 trap '' EXIT
104 exit $status
105 }
106
107 #### Exit with error message.
108 die() {
109 status=1 # It should already be, but just in case the code below changes.
110 echo "$0: $*" 1>&2
111 cleanup
112 }
113
114 #### Download sources from repo. With git and on master, the
115 #### directory will be nmh, but with snapshot, it will be
116 #### nmh-master.
117 download_sources() {
118 [ $verbose -ge 1 ] && echo downloading . . . >&3
119 gitdir=`finddir git`
120 if [ "$gitdir" ]; then
121 #### Use git repo.
122 [ "$verbose" -eq 0 ] && git_opts=--quiet
123 [ "$branch" = master ] ||
124 git_opts="${git_opts:+$git_opts }--branch $branch"
125 if "$gitdir"/git clone --depth 1 $git_opts "git://$gitrepo/nmh.git" >&3
126 then
127 directory=nmh
128 cd "$directory" || die "failed to clone $directory"
129 printf "commit %s\n" `git log --max-count=1 --pretty=format:%H`
130 else
131 die 'failed to clone git repo'
132 fi
133 else
134 [ -e nmh-"$branch" ] && die "nmh-$branch exists, will not overrwrite"
135
136 #### Use snapshot.
137 tarball="nmh-$branch.tar.gz"
138 repo="http://$gitrepo/cgit/nmh.git/snapshot"
139 snapshot="$repo/$tarball"
140 if [ "`finddir wget`" ]; then
141 [ "$verbose" -eq 0 ] && wget_opts='--quiet'
142 wget --output-document - $wget_opts "$snapshot" 2>&3 | gzip -d | tar xf -
143 elif [ "`finddir curl`" ]; then
144 [ "$verbose" -eq 0 ] && curl_opts='--silent --show-error'
145 curl --location $curl_opts "$snapshot" 2>&3 | gzip -d | tar xf -
146 else
147 die 'unable to find program to download nmh sources'
148 fi
149
150 if [ -d nmh-"$branch" ]; then
151 directory=nmh-"$branch"
152 cd "$directory" || die "failed to download and extract $directory"
153 else
154 die "failed to download nmh-$branch sources"
155 fi
156 fi
157 }
158
159 directory=
160 download=0
161 gitrepo=git.savannah.nongnu.org
162 invocation="$0 $*"
163 status=1
164 tmpfile=/tmp/build_nmh-$$.log
165
166 #### Redirect all output to tmp file. Then on EXIT, copy it to either
167 #### logfile or stdout. Also, grep it for errors and warnings. Set
168 #### tmpfile just prior to this, see cleanup().
169 exec 3>&1 4>&2 >"$tmpfile" 2>&1
170
171
172 ####
173 #### Interpret command arguments.
174 ####
175 branch=master
176 check=check
177 debug=0
178 install=0
179 build_rpm=0
180 superclean=0
181 verbose=0
182 yes=0
183
184 #### With dash, heirloom shell, and posh, need to catch INT and QUIT
185 #### in order for cleanup to be call: just EXIT isn't sufficient.
186 trap cleanup EXIT INT QUIT
187
188 while getopts 'cb:dil:rsvy?' arg; do
189 case $arg in
190 b ) branch="$OPTARG" ;;
191 c ) check=distcheck ;;
192 d ) debug=1 ;;
193 i ) install=1 ;;
194 l ) logfile=$OPTARG ;;
195 r ) build_rpm=1 ;;
196 s ) superclean=1 ;;
197 v ) verbose=1 ;;
198 y ) yes=1 ;;
199 '?') echo "$0: $usage"; logfile=-; status=0; exit ;;
200 esac
201 done
202 shift `expr $OPTIND - 1`
203
204 echo "$invocation"
205
206 #### No non-option command line arguments are supported.
207 [ $# -gt 0 ] && die "$usage"
208
209 #### Check to see that we're in a nmh source directory.
210 if grep 'the authors of nmh' COPYRIGHT >/dev/null 2>&1; then
211 :
212 else
213 download=1
214 fi
215
216 ####
217 #### Set up configure options.
218 ####
219
220 #### Here are the config options that we will try to detect, then
221 #### confirm, and finally set.
222 config_prefix=/usr/local/nmh
223 config_locking=
224 config_mts=smtp
225 config_smtpserver=localhost
226 config_sasl='determined by configure'
227 config_tls='determined by configure'
228 config_debug=n
229
230
231 #### Figure out whether or not to use -n with tail.
232 case `printf 'OK\n' | tail -n 1 2>&1` in
233 OK) tail='tail -n ' ;;
234 *) tail='tail -' ;;
235 esac
236
237 if install-mh -check >/dev/null 2>&1; then
238 #### Determine config options from installed nmh.
239 mhbin=`finddir install-mh`
240
241 config_prefix=`cd $mhbin/.. && pwd`
242
243 mtsconf=`mhparam etcdir`/mts.conf
244 if [ -f "$mtsconf" ]; then
245 mts_entry=`grep '^mts:' "$mtsconf"`
246 if [ "$mts_entry" ]; then
247 mts=`echo "$mts_entry" | sed -e 's/^mts: *//'`
248 if [ "$mts" -a "$mts" != smtp ]; then
249 config_mts="$mts"
250 fi
251 fi
252
253 mtsconfservers=`grep '^servers:' "$mtsconf"`
254 if [ "$mtsconfservers" ]; then
255 servers=`echo "$mtsconfservers" | sed -e 's/^servers: *//'`
256 [ "$servers" ] && config_smtpserver="$servers"
257 fi
258 fi
259
260 if test -x "$mhbin/mhparam"; then
261 if mhparam sasl >/dev/null; then
262 case `$mhbin/mhparam sasl` in
263 *sasl*) config_sasl=y ;;
264 esac
265
266 case `$mhbin/mhparam tls` in
267 *tls*) config_tls=y ;;
268 esac
269 else
270 tput smso
271 echo "$0: SASL and TLS detection not supported with current nmh"
272 [ $yes -eq 1 ] && echo "configure will determine whether to enable"
273 tput rmso
274 fi
275 fi
276 fi
277
278 #### Don't confirm debug interactively below; obey the -d option.
279 [ $debug -ge 1 ] && config_debug=y
280
281 if [ $yes -eq 0 ]; then
282 #### Confirm each config setting with user.
283 printf 'Install prefix [%s]: ' $config_prefix >&3
284 read prefix
285 [ "$prefix" ] && config_prefix="$prefix"
286
287 printf 'Locking type (dot|fcntl|flock|lockf) [determined by configure]: ' >&3
288 read locking
289 [ "$locking" ] && config_locking="$locking"
290
291 printf 'MTS (smtp|sendmail/smtp|sendmail/pipe) [%s]: ' $config_mts >&3
292 read mts
293 [ "$mts" ] && config_mts="$mts"
294
295 if [ "$config_mts" = smtp ]; then
296 printf 'SMTP server [%s]: ' $config_smtpserver >&3
297 read server
298 [ "$server" ] && config_smtpserver="$servers"
299 fi
300
301 printf 'Cyrus SASL support (y|n) [%s]: ' "$config_sasl" >&3
302 read response
303 [ "$response" = y -o "$response" = Y ] && config_sasl=y
304
305 printf 'TLS support (y|n) [%s]: ' "$config_tls" >&3
306 read response
307 [ "$response" = y -o "$response" = Y ] && config_tls=y
308 fi
309
310 config_opts="--prefix=$config_prefix"
311
312 [ "$config_locking" ] &&
313 config_opts="$config_opts --with-locking=$config_locking"
314 [ "$config_mts" -a "$config_mts" != smtp ] &&
315 config_opts="$config_opts --with-mts=$config_mts"
316 [ "$config_smtpserver" -a "$config_smtpserver" != localhost ] &&
317 config_opts="$config_opts --with-smtpserver=$config_smtpserver"
318 [ "$config_sasl" = y ] && config_opts="$config_opts --with-cyrus-sasl"
319 [ "$config_tls" = y ] && config_opts="$config_opts --with-tls"
320 [ $config_debug = y ] && config_opts="$config_opts --enable-assert"
321
322 #### dotlocking, the usual default, requires chgrp and chmod of inc.
323 installpriv=
324 if [ $install -ge 1 -a "$LOGNAME" != root ]; then
325 if [ "$config_locking" = dot ]; then
326 echo "$0: "'install requires chgrp and chmod 2755'
327 echo 'so will sudo to install. Terminate with Ctrl-C if unacceptable.'
328 installpriv=sudo
329 fi
330 fi
331
332 printf '\n%s %s %s %s\n\n' "`uname -m`" "`uname -s`" "`uname -r`" "`uname -v`"
333 [ -f /etc/os-release ] && printf '%s\n\n' "`cat /etc/os-release`"
334
335 [ $download -eq 1 ] && download_sources
336
337 ####
338 #### Set up with autoconfig if necessary.
339 ####
340 if [ -f Makefile ]; then
341 [ $verbose -ge 1 ] && echo cleaning . . . >&3
342 if [ $superclean -ge 1 ]; then
343 make superclean >/dev/null
344 else
345 make distclean >/dev/null
346 fi
347 fi
348
349 if [ ! -f configure -o ! -f Makefile.in ]; then
350 [ $verbose -ge 1 ] && echo autoconfiguring . . . >&3
351 ./autogen.sh
352 [ $? -ne 0 ] &&
353 die "autogen failed, see MACHINES file for autoconf,
354 automake, flex, and bison requirements"
355 fi
356
357
358 ####
359 #### Build.
360 ####
361 [ $verbose -ge 1 ] && echo configuring . . . >&3
362 if [ -z "$CFLAGS" ]; then
363 #### Only use these flags with gcc.
364 if cc -dM -E - </dev/null 2>&1 | grep __GNUC__ >/dev/null; then
365 #### configure will supply -g -O2 with gcc, but only if CFLAGS
366 #### isn't defined.
367 CFLAGS='-g -ansi -pedantic'
368 if [ "$config_debug" = n ]; then
369 CFLAGS="$CFLAGS -O2"
370 else
371 CFLAGS="$CFLAGS -O0"
372 fi
373 fi
374 fi
375
376 printf "\n./configure ${CFLAGS:+CFLAGS=\"${CFLAGS}\" }$config_opts\n"
377 ./configure ${CFLAGS:+CFLAGS="${CFLAGS}"" "}$config_opts
378 status=$?
379
380 if [ $status -eq 0 ]; then
381 [ $verbose -ge 1 ] && echo building . . . >&3
382 make
383 status=$?
384
385 if [ $status -eq 0 ]; then
386 if [ "$TESTS_SHELL"x = x ]; then
387 #### Bonus: use heirloom shell to test, if available, and if
388 #### TESTS_SHELL hadn't already been set.
389 heirloom_shell=/usr/lib/heirloom/5bin/sh
390 if [ -x "$heirloom_shell" ]; then
391 TESTS_SHELL="$heirloom_shell"; export TESTS_SHELL
392 fi
393 fi
394
395 if [ "$CFLAGS" ]; then
396 #### Pass DISTCHECK_CONFIGURE_FLAGS through an environment
397 #### variable to avoid automake's quoting.
398 DISTCHECK_CONFIGURE_FLAGS="CFLAGS='${CFLAGS}'"
399 export DISTCHECK_CONFIGURE_FLAGS
400 fi
401
402 [ $verbose -ge 1 ] && echo testing . . . >&3
403 [ "${TERM:-dumb}" = dumb ] && color=no || color=always
404 checkoutput=`make $check AM_COLOR_TESTS=$color`
405 status=$?
406
407 tests_summary=`echo "$checkoutput" | grep tests`
408 #### If multiple tests not run, that line will be caught by the
409 #### "grep tests" above.
410 test_not_run=`echo "$checkoutput" | grep 'test was not run'`
411 fails=`echo "$checkoutput" | grep FAIL`
412 if [ "$tests_summary" ]; then
413 echo '==================='
414 [ "$test_not_run" ] && echo "$test_not_run"
415 [ "$fails" ] && echo "$fails"
416 echo "$tests_summary"
417 echo '==================='
418 [ "$check" = distcheck ] && echo "$checkoutput" | ${tail}4
419 fi
420
421 if [ $status -eq 0 ]; then
422 if [ $install -ge 1 ]; then
423 [ $verbose -ge 1 ] && echo installing . . . >&3
424 ($installpriv make install) >/dev/null
425 status=$?
426 fi
427
428 if [ $status -eq 0 -a $build_rpm -ge 1 ]; then
429 [ $verbose -ge 1 ] && echo building rpm . . . >&3
430 make rpm >/dev/null
431 status=$?
432 fi
433 fi
434 fi
435 else
436 echo "see nmh MACHINES file for build dependences"
437 fi
438
439 #### Will call cleanup, which will exit with $status.
440 exit